var Backbone = require('backbone')

Backbone.register = function(config) {
  Lilo.Model.urlRoot = config.urlRoot
  new Lilo.Router({ app: config.app, routes: config.routes })

  if (!Backbone.View.config) {
    Backbone.View.config = {}
  }

  if (config.layoutPath) {
    Backbone.View.config.layoutPath = config.layoutPath
  }
  if (config.layoutViews) {
    Backbone.View.config.layoutViews = config.layoutViews
  }
  if (config.templatePath) {
    Backbone.View.config.templatePath = config.templatePath
  }
  if (config.layout) {
    Backbone.View.config.layout = config.layout
  }

  config.app.get(config.packagePath, Lilo.packager.createPackage({
    dependencies: config.deps
  }).createServer())
}

Backbone.ajax = require('./lib/server/request')
Backbone.packager = require('./lib/server/packager')
Backbone.Router = require('./lib/server/router')
Backbone.View = require('./lib/server/view')

Lilo = module.exports = Backbone
